=== core/dplugins/CMakeLists.txt ===
#
# Copyright (c) 2010-2019 by Gilles Caulier, <caulier dot gilles at gmail dot com>
#
# Redistribution and use is allowed according to the terms of the BSD license.
# For details see the accompanying COPYING-CMAKE-SCRIPTS file.

add_subdirectory(generic)
add_subdirectory(editor)
add_subdirectory(bqm)
add_subdirectory(rawimport)
add_subdirectory(dimg)
