=== core/tests/CMakeLists.txt ===
#
# Copyright (c) 2010-2019 by Gilles Caulier, <caulier dot gilles at gmail dot com>
#
# Redistribution and use is allowed according to the terms of the BSD license.
# For details see the accompanying COPYING-CMAKE-SCRIPTS file.

# enabling for everything although only required by DImg.
kde_enable_exceptions()

if(APPLE)
    set(_extra_deps /System/Library/Frameworks/AppKit.framework)
endif()

set(COMMON_TEST_LINK Qt5::Core
                     Qt5::Gui
                     Qt5::Xml
                     Qt5::XmlPatterns
                     Qt5::Widgets
                     Qt5::Concurrent
                     Qt5::Test
                     Qt5::Sql

                     KF5::XmlGui
                     KF5::I18n
                     KF5::ConfigCore
                     KF5::Service
                     KF5::Solid

                     ${_extra_deps}
)

add_subdirectory(albummodel)
add_subdirectory(advancedrename)
add_subdirectory(database)
add_subdirectory(dialogs)
add_subdirectory(dimg)
add_subdirectory(metadataengine)
add_subdirectory(facesengine)
add_subdirectory(geolocation)
add_subdirectory(imgqsort)
add_subdirectory(iojobs)
add_subdirectory(multithreading)
add_subdirectory(fileio)
add_subdirectory(filters)
add_subdirectory(timestampupdate)
add_subdirectory(widgets)
add_subdirectory(rawengine)
add_subdirectory(webservices)
add_subdirectory(dplugins)

if(ENABLE_MEDIAPLAYER)
    add_subdirectory(video)
endif()

if(ENABLE_DIGIKAM_MODELTEST)
    message(STATUS "Modeltest enabled")
    set(libdigikamgui_SRCS ${libdigikamgui_SRCS}
        modeltest/modeltest.cpp
       )
    add_definitions(-DENABLE_DIGIKAM_MODELTEST)
endif()
