=== debian/changelog ===
digikam (4:6.4.0+dfsg-3~mx19+1) mx; urgency=medium

  * Rebuild for MX Linux.
  * Disable 0002-Fix-to-build-with-OpenCV-4.2.0.patch.
  * Try building against Buster's libqtav-dev 1.12.
  * Add desktops-fix-GUI-startup-on-MX.patch.

 -- Steven Pusser <stevep@mxlinux.org>  Sun, 26 Jul 2020 15:58:32 -0700

digikam (4:6.4.0+dfsg-3) unstable; urgency=medium

  [ Steve Robbins ]
  * Build-dep on all FFmpeg libraries to enable media player support.

 -- Steve M. Robbins <smr@debian.org>  Tue, 11 Feb 2020 00:48:08 -0600

digikam (4:6.4.0+dfsg-2) unstable; urgency=medium

  [ Frédéric Bonnard ]
  * Fix FTBFS on ppc64el with opencv 4.  Closes: #950731.

 -- Steve M. Robbins <smr@debian.org>  Wed, 05 Feb 2020 23:11:57 -0600

digikam (4:6.4.0+dfsg-1) unstable; urgency=medium

  [ Steve Robbins ]
  * New upstream version 6.4.0
    - repacked to remove minified javascript and project/bundles.
  * Retroactive NEWS item about QtAV support
  * Remove kipi -- support removed upstream
  * Update to debhelper compat=12; remove dh --parallel as it is now default.
  * Build with libx265-dev
  * Don't build digikam-doc; upstream sources no longer contain docs.

 -- Steve M. Robbins <smr@debian.org>  Sun, 02 Feb 2020 21:13:33 -0600

digikam (4:6.2.0-1) unstable; urgency=medium

  [ Steven Robbins ]
  * [8ec8059] Fix debian/watch; add signature validation
  * [ab3b314] New upstream version 6.2.0
  * [e59ff14] rebase patches

 -- Steve M. Robbins <smr@debian.org>  Sun, 01 Sep 2019 02:05:59 -0500

digikam (4:5.9.0-2) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/changelog: Remove trailing whitespaces
  * d/control: Remove trailing whitespaces
  * d/rules: Remove trailing whitespaces

  [ Steve M. Robbins ]

 -- Steve M. Robbins <smr@debian.org>  Wed, 21 Nov 2018 21:11:07 -0600
